// Generated by Ignite ignite.com/cli

import { StdFee } from "@cosmjs/launchpad";
import { SigningStargateClient, DeliverTxResponse } from "@cosmjs/stargate";
import { EncodeObject, GeneratedType, OfflineSigner, Registry } from "@cosmjs/proto-signing";
import { msgTypes } from './registry';
import { IgniteClient } from "../client"
import { MissingWalletError } from "../helpers"
import { Api } from "./rest";
import { MsgUpdateDidDocument } from "./types/did/tx";
import { MsgDeleteController } from "./types/did/tx";
import { MsgDeleteService } from "./types/did/tx";
import { MsgAddController } from "./types/did/tx";
import { MsgAddVerification } from "./types/did/tx";
import { MsgAddService } from "./types/did/tx";
import { MsgCreateDidDocument } from "./types/did/tx";
import { MsgSetVerificationRelationships } from "./types/did/tx";
import { MsgRevokeVerification } from "./types/did/tx";


export { MsgUpdateDidDocument, MsgDeleteController, MsgDeleteService, MsgAddController, MsgAddVerification, MsgAddService, MsgCreateDidDocument, MsgSetVerificationRelationships, MsgRevokeVerification };

type sendMsgUpdateDidDocumentParams = {
  value: MsgUpdateDidDocument,
  fee?: StdFee,
  memo?: string
};

type sendMsgDeleteControllerParams = {
  value: MsgDeleteController,
  fee?: StdFee,
  memo?: string
};

type sendMsgDeleteServiceParams = {
  value: MsgDeleteService,
  fee?: StdFee,
  memo?: string
};

type sendMsgAddControllerParams = {
  value: MsgAddController,
  fee?: StdFee,
  memo?: string
};

type sendMsgAddVerificationParams = {
  value: MsgAddVerification,
  fee?: StdFee,
  memo?: string
};

type sendMsgAddServiceParams = {
  value: MsgAddService,
  fee?: StdFee,
  memo?: string
};

type sendMsgCreateDidDocumentParams = {
  value: MsgCreateDidDocument,
  fee?: StdFee,
  memo?: string
};

type sendMsgSetVerificationRelationshipsParams = {
  value: MsgSetVerificationRelationships,
  fee?: StdFee,
  memo?: string
};

type sendMsgRevokeVerificationParams = {
  value: MsgRevokeVerification,
  fee?: StdFee,
  memo?: string
};


type msgUpdateDidDocumentParams = {
  value: MsgUpdateDidDocument,
};

type msgDeleteControllerParams = {
  value: MsgDeleteController,
};

type msgDeleteServiceParams = {
  value: MsgDeleteService,
};

type msgAddControllerParams = {
  value: MsgAddController,
};

type msgAddVerificationParams = {
  value: MsgAddVerification,
};

type msgAddServiceParams = {
  value: MsgAddService,
};

type msgCreateDidDocumentParams = {
  value: MsgCreateDidDocument,
};

type msgSetVerificationRelationshipsParams = {
  value: MsgSetVerificationRelationships,
};

type msgRevokeVerificationParams = {
  value: MsgRevokeVerification,
};


export const registry = new Registry(msgTypes);

const defaultFee = {
  amount: [],
  gas: "200000",
};

interface TxClientOptions {
  addr: string
	prefix: string
	signer?: OfflineSigner
}

export const txClient = ({ signer, prefix, addr }: TxClientOptions = { addr: "http://localhost:26657", prefix: "cosmos" }) => {

  return {
		
		async sendMsgUpdateDidDocument({ value, fee, memo }: sendMsgUpdateDidDocumentParams): Promise<DeliverTxResponse> {
			if (!signer) {
					throw new Error('TxClient:sendMsgUpdateDidDocument: Unable to sign Tx. Signer is not present.')
			}
			try {			
				const { address } = (await signer.getAccounts())[0]; 
				const signingClient = await SigningStargateClient.connectWithSigner(addr,signer,{registry, prefix});
				let msg = this.msgUpdateDidDocument({ value: MsgUpdateDidDocument.fromPartial(value) })
				return await signingClient.signAndBroadcast(address, [msg], fee ? fee : defaultFee, memo)
			} catch (e: any) {
				throw new Error('TxClient:sendMsgUpdateDidDocument: Could not broadcast Tx: '+ e.message)
			}
		},
		
		async sendMsgDeleteController({ value, fee, memo }: sendMsgDeleteControllerParams): Promise<DeliverTxResponse> {
			if (!signer) {
					throw new Error('TxClient:sendMsgDeleteController: Unable to sign Tx. Signer is not present.')
			}
			try {			
				const { address } = (await signer.getAccounts())[0]; 
				const signingClient = await SigningStargateClient.connectWithSigner(addr,signer,{registry, prefix});
				let msg = this.msgDeleteController({ value: MsgDeleteController.fromPartial(value) })
				return await signingClient.signAndBroadcast(address, [msg], fee ? fee : defaultFee, memo)
			} catch (e: any) {
				throw new Error('TxClient:sendMsgDeleteController: Could not broadcast Tx: '+ e.message)
			}
		},
		
		async sendMsgDeleteService({ value, fee, memo }: sendMsgDeleteServiceParams): Promise<DeliverTxResponse> {
			if (!signer) {
					throw new Error('TxClient:sendMsgDeleteService: Unable to sign Tx. Signer is not present.')
			}
			try {			
				const { address } = (await signer.getAccounts())[0]; 
				const signingClient = await SigningStargateClient.connectWithSigner(addr,signer,{registry, prefix});
				let msg = this.msgDeleteService({ value: MsgDeleteService.fromPartial(value) })
				return await signingClient.signAndBroadcast(address, [msg], fee ? fee : defaultFee, memo)
			} catch (e: any) {
				throw new Error('TxClient:sendMsgDeleteService: Could not broadcast Tx: '+ e.message)
			}
		},
		
		async sendMsgAddController({ value, fee, memo }: sendMsgAddControllerParams): Promise<DeliverTxResponse> {
			if (!signer) {
					throw new Error('TxClient:sendMsgAddController: Unable to sign Tx. Signer is not present.')
			}
			try {			
				const { address } = (await signer.getAccounts())[0]; 
				const signingClient = await SigningStargateClient.connectWithSigner(addr,signer,{registry, prefix});
				let msg = this.msgAddController({ value: MsgAddController.fromPartial(value) })
				return await signingClient.signAndBroadcast(address, [msg], fee ? fee : defaultFee, memo)
			} catch (e: any) {
				throw new Error('TxClient:sendMsgAddController: Could not broadcast Tx: '+ e.message)
			}
		},
		
		async sendMsgAddVerification({ value, fee, memo }: sendMsgAddVerificationParams): Promise<DeliverTxResponse> {
			if (!signer) {
					throw new Error('TxClient:sendMsgAddVerification: Unable to sign Tx. Signer is not present.')
			}
			try {			
				const { address } = (await signer.getAccounts())[0]; 
				const signingClient = await SigningStargateClient.connectWithSigner(addr,signer,{registry, prefix});
				let msg = this.msgAddVerification({ value: MsgAddVerification.fromPartial(value) })
				return await signingClient.signAndBroadcast(address, [msg], fee ? fee : defaultFee, memo)
			} catch (e: any) {
				throw new Error('TxClient:sendMsgAddVerification: Could not broadcast Tx: '+ e.message)
			}
		},
		
		async sendMsgAddService({ value, fee, memo }: sendMsgAddServiceParams): Promise<DeliverTxResponse> {
			if (!signer) {
					throw new Error('TxClient:sendMsgAddService: Unable to sign Tx. Signer is not present.')
			}
			try {			
				const { address } = (await signer.getAccounts())[0]; 
				const signingClient = await SigningStargateClient.connectWithSigner(addr,signer,{registry, prefix});
				let msg = this.msgAddService({ value: MsgAddService.fromPartial(value) })
				return await signingClient.signAndBroadcast(address, [msg], fee ? fee : defaultFee, memo)
			} catch (e: any) {
				throw new Error('TxClient:sendMsgAddService: Could not broadcast Tx: '+ e.message)
			}
		},
		
		async sendMsgCreateDidDocument({ value, fee, memo }: sendMsgCreateDidDocumentParams): Promise<DeliverTxResponse> {
			if (!signer) {
					throw new Error('TxClient:sendMsgCreateDidDocument: Unable to sign Tx. Signer is not present.')
			}
			try {			
				const { address } = (await signer.getAccounts())[0]; 
				const signingClient = await SigningStargateClient.connectWithSigner(addr,signer,{registry, prefix});
				let msg = this.msgCreateDidDocument({ value: MsgCreateDidDocument.fromPartial(value) })
				return await signingClient.signAndBroadcast(address, [msg], fee ? fee : defaultFee, memo)
			} catch (e: any) {
				throw new Error('TxClient:sendMsgCreateDidDocument: Could not broadcast Tx: '+ e.message)
			}
		},
		
		async sendMsgSetVerificationRelationships({ value, fee, memo }: sendMsgSetVerificationRelationshipsParams): Promise<DeliverTxResponse> {
			if (!signer) {
					throw new Error('TxClient:sendMsgSetVerificationRelationships: Unable to sign Tx. Signer is not present.')
			}
			try {			
				const { address } = (await signer.getAccounts())[0]; 
				const signingClient = await SigningStargateClient.connectWithSigner(addr,signer,{registry, prefix});
				let msg = this.msgSetVerificationRelationships({ value: MsgSetVerificationRelationships.fromPartial(value) })
				return await signingClient.signAndBroadcast(address, [msg], fee ? fee : defaultFee, memo)
			} catch (e: any) {
				throw new Error('TxClient:sendMsgSetVerificationRelationships: Could not broadcast Tx: '+ e.message)
			}
		},
		
		async sendMsgRevokeVerification({ value, fee, memo }: sendMsgRevokeVerificationParams): Promise<DeliverTxResponse> {
			if (!signer) {
					throw new Error('TxClient:sendMsgRevokeVerification: Unable to sign Tx. Signer is not present.')
			}
			try {			
				const { address } = (await signer.getAccounts())[0]; 
				const signingClient = await SigningStargateClient.connectWithSigner(addr,signer,{registry, prefix});
				let msg = this.msgRevokeVerification({ value: MsgRevokeVerification.fromPartial(value) })
				return await signingClient.signAndBroadcast(address, [msg], fee ? fee : defaultFee, memo)
			} catch (e: any) {
				throw new Error('TxClient:sendMsgRevokeVerification: Could not broadcast Tx: '+ e.message)
			}
		},
		
		
		msgUpdateDidDocument({ value }: msgUpdateDidDocumentParams): EncodeObject {
			try {
				return { typeUrl: "/allinbits.cosmoscash.did.MsgUpdateDidDocument", value: MsgUpdateDidDocument.fromPartial( value ) }  
			} catch (e: any) {
				throw new Error('TxClient:MsgUpdateDidDocument: Could not create message: ' + e.message)
			}
		},
		
		msgDeleteController({ value }: msgDeleteControllerParams): EncodeObject {
			try {
				return { typeUrl: "/allinbits.cosmoscash.did.MsgDeleteController", value: MsgDeleteController.fromPartial( value ) }  
			} catch (e: any) {
				throw new Error('TxClient:MsgDeleteController: Could not create message: ' + e.message)
			}
		},
		
		msgDeleteService({ value }: msgDeleteServiceParams): EncodeObject {
			try {
				return { typeUrl: "/allinbits.cosmoscash.did.MsgDeleteService", value: MsgDeleteService.fromPartial( value ) }  
			} catch (e: any) {
				throw new Error('TxClient:MsgDeleteService: Could not create message: ' + e.message)
			}
		},
		
		msgAddController({ value }: msgAddControllerParams): EncodeObject {
			try {
				return { typeUrl: "/allinbits.cosmoscash.did.MsgAddController", value: MsgAddController.fromPartial( value ) }  
			} catch (e: any) {
				throw new Error('TxClient:MsgAddController: Could not create message: ' + e.message)
			}
		},
		
		msgAddVerification({ value }: msgAddVerificationParams): EncodeObject {
			try {
				return { typeUrl: "/allinbits.cosmoscash.did.MsgAddVerification", value: MsgAddVerification.fromPartial( value ) }  
			} catch (e: any) {
				throw new Error('TxClient:MsgAddVerification: Could not create message: ' + e.message)
			}
		},
		
		msgAddService({ value }: msgAddServiceParams): EncodeObject {
			try {
				return { typeUrl: "/allinbits.cosmoscash.did.MsgAddService", value: MsgAddService.fromPartial( value ) }  
			} catch (e: any) {
				throw new Error('TxClient:MsgAddService: Could not create message: ' + e.message)
			}
		},
		
		msgCreateDidDocument({ value }: msgCreateDidDocumentParams): EncodeObject {
			try {
				return { typeUrl: "/allinbits.cosmoscash.did.MsgCreateDidDocument", value: MsgCreateDidDocument.fromPartial( value ) }  
			} catch (e: any) {
				throw new Error('TxClient:MsgCreateDidDocument: Could not create message: ' + e.message)
			}
		},
		
		msgSetVerificationRelationships({ value }: msgSetVerificationRelationshipsParams): EncodeObject {
			try {
				return { typeUrl: "/allinbits.cosmoscash.did.MsgSetVerificationRelationships", value: MsgSetVerificationRelationships.fromPartial( value ) }  
			} catch (e: any) {
				throw new Error('TxClient:MsgSetVerificationRelationships: Could not create message: ' + e.message)
			}
		},
		
		msgRevokeVerification({ value }: msgRevokeVerificationParams): EncodeObject {
			try {
				return { typeUrl: "/allinbits.cosmoscash.did.MsgRevokeVerification", value: MsgRevokeVerification.fromPartial( value ) }  
			} catch (e: any) {
				throw new Error('TxClient:MsgRevokeVerification: Could not create message: ' + e.message)
			}
		},
		
	}
};

interface QueryClientOptions {
  addr: string
}

export const queryClient = ({ addr: addr }: QueryClientOptions = { addr: "http://localhost:1317" }) => {
  return new Api({ baseUrl: addr });
};

class SDKModule {
	public query: ReturnType<typeof queryClient>;
	public tx: ReturnType<typeof txClient>;
	
	public registry: Array<[string, GeneratedType]>;

	constructor(client: IgniteClient) {		
	
		this.query = queryClient({ addr: client.env.apiURL });
		this.tx = txClient({ signer: client.signer, addr: client.env.rpcURL, prefix: client.env.prefix ?? "cosmos" });
	}
};

const Module = (test: IgniteClient) => {
	return {
		module: {
			AllinbitsCosmoscashDid: new SDKModule(test)
		},
		registry: msgTypes
  }
}
export default Module;